///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: ComException.cpp $
// Version        : $Revision: 1 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 22/07/99 23:56 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /JetByteTools/COM Tools/ComException.cpp $
// 
// 1     22/07/99 23:56 Len
// Moved to source safe
// 
//    Rev 1.3   May 13 1999 23:07:42   len
// Half-hearted attempt to add com error info conversion function.
// 
//    Rev 1.2   Oct 25 1998 21:18:30   len
// 
//    Rev 1.1   Aug 30 1998 16:27:24   len
// 
//    Rev 1.0   May 18 1998 07:34:42   Len
// Initial revision.
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1998 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Include files
///////////////////////////////////////////////////////////////////////////////

#include "ComException.hpp"

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {

///////////////////////////////////////////////////////////////////////////////
// CComException
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Construction and destruction
///////////////////////////////////////////////////////////////////////////////

CComException::CComException(LPCTSTR pWhere, HRESULT hr)
   :  CWin32Exception(pWhere, hr)
{

}

LPCTSTR CComException::GetMessage() const 
{ 
	return CWin32Exception::GetMessage();
}

#if 0
HRESULT CComException::SetAsComErrorInfo(
	REFIID iid, 
	LPCTSTR pSource /*= 0*/,
	LPCTSTR pHelpFile /*= 0*/,
	DWORD dwHelpContext /*= 0*/) const
{
	ICreateErrorInfo *pICreateError = 0;

	HRESULT hr = CreateErrorInfo(&pICreateError);

	if (FAILED(hr))
	{
		throw CComException(_T(""), hr);
	}

	// Fill in the stuff here

	hr = pICreateError->SetGUID(iid);

	if (FAILED(hr))
	{
		throw CComException(_T(""), hr);
	}

//	need convert to bstrs
//	hr = SetDescription();




	IErrorInfo *pIErrorInfo = 0;

	hr = pICreateError->QueryInterface(IID_IErrorInfo, (void**)&pIErrorInfo);

	pICreateError->Release();

	if (FAILED(hr))
	{
		throw CComException(_T(""), hr);
	}

	SetErrorInfo(0, pIErrorInfo);

	pIErrorInfo->Release();

	return m_error;
}
#endif
///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

} // End of namespace JetByteTools 

///////////////////////////////////////////////////////////////////////////////
// End of file...
///////////////////////////////////////////////////////////////////////////////
