#ifndef __COM_EXE_SERVER__
#define __COM_EXE_SERVER__
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: ComExeServer.hpp $
// Version        : $Revision: 2 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 6/03/00 7:42 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /Source/JetByteTools/COMTools/ComExeServer.hpp $
// 
// 2     6/03/00 7:42 Len
// Exclude from the build unless we're building for NT4 / 95+DCOM only.
// 
// 1     22/07/99 23:56 Len
// Moved to source safe
// 
//    Rev 1.0   May 13 1999 23:17:12   len
// Initial revision.
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1999 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM)

#ifndef _WINDOWS_
//#define WIN32_LEAN_AND_MEAN
#include <windows.h>
//#undef WIN32_LEAN_AND_MEAN
#endif

#ifndef _INC_TCHAR
#include <tchar.h>
#endif

#ifndef __LINKED_CLASS__
#include "LinkedClass.hpp"
#endif

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {
 
///////////////////////////////////////////////////////////////////////////////
// Classes defined in this file...
///////////////////////////////////////////////////////////////////////////////

class CComExeServer;

///////////////////////////////////////////////////////////////////////////////
// Classes defined in other files...
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// CComExeServer
///////////////////////////////////////////////////////////////////////////////

class CComExeServer : public TLinkedClass<CComExeServer>
{
   public :

		CComExeServer();

		virtual ~CComExeServer();

      static void Run(HINSTANCE hInstance, LPCTSTR lpCmdLine);

		static ULONG Lock();
		static ULONG Unlock();

	protected :

		virtual void RegisterServer(LPCTSTR lpCmdLine);

		virtual void UnregisterServer(LPCTSTR lpCmdLine);
		
		virtual bool InitInstance(LPCTSTR lpCmdLine);
		
		virtual void RegisterClassObject() = 0;
		
		virtual void RevokeClassObject();
		
		virtual void ShutdownInstance();

		static HINSTANCE s_hInstance;

		void RegisterClassObject(
			const CLSID &clsid,
			IUnknown *pUnknown);

	private :

		static bool Initialise(
			HINSTANCE hInstance, 
			LPCTSTR lpCmdLine);

		static bool ParseCommandLine(LPCTSTR lpCmdLine);

		static void RegisterServers(LPCTSTR lpCmdLine);

		static void UnregisterServers(LPCTSTR lpCmdLine);

		static void RegisterClassObjects();
		static void RevokeClassObjects();

		static void Shutdown();

		static HANDLE s_hEventDone;

		static void SetRunAs(
			LPCTSTR pAppId, 
			LPCTSTR pUser,
			LPCTSTR pPassword);


		DWORD m_dwReg;

		// Prevent copying, don't implement

		CComExeServer(const CComExeServer &rhs);
		CComExeServer &operator=(const CComExeServer &rhs);
};

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

} // End of namespace JetByteTools 

#endif // (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM)

#endif // __COM_EXE_SERVER__

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
