#ifndef __COM_EXE_SERVER_MAIN__
#define __COM_EXE_SERVER_MAIN__
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: ComExeServerMain.hpp $
// Version        : $Revision: 1 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 22/07/99 23:56 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /JetByteTools/COM Tools/ComExeServerMain.hpp $
// 
// 1     22/07/99 23:56 Len
// Moved to source safe
// 
//    Rev 1.0   May 13 1999 23:17:40   len
// Initial revision.
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1999 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#include "Win32Exception.hpp"

///////////////////////////////////////////////////////////////////////////////
// WinMain
///////////////////////////////////////////////////////////////////////////////

#ifndef _MFC_COM_SERVER_EXE

// the main thread routine that simply registers the class
// object and waits to die
int APIENTRY WinMain(
    HINSTANCE hInstance,
    HINSTANCE /*hPrevInstance*/,
    LPSTR /*lpCmdLine */,
    int /*nCmdShow*/)
{
	const int c_Success = 0;
	const int c_Failure = 1;

	int retVal = c_Success;

	try
	{
		LPCTSTR lpCmdLine = GetCommandLine();

		JetByteTools::CComExeServer::Run(hInstance, lpCmdLine);
	}
	catch (JetByteTools::CWin32Exception &e)
	{
		e.MessageBox();

		retVal = c_Failure;
	}
	catch (...)
	{
		::MessageBox(
			NULL, 
			_T("Unexpected Exception"), 
			_T("Program Failed"), 
			MB_ICONINFORMATION);
	
		retVal = c_Failure;
	}

	return retVal;
}

#else // MFC

int APIENTRY WinMain(
    HINSTANCE hInstance,
    HINSTANCE hPrevInstance,
    LPSTR /*lpCmdLine*/,
    int nCmdShow)
{
   CWinApp theApp;

   LPTSTR lpCmdLine = GetCommandLine();

   int retVal = AfxWinInit(hInstance, hPrevInstance, lpCmdLine, nCmdShow);

	if (retVal)
	{
		const int c_Success = 0;
		const int c_Failure = 1;

		retVal = c_Success;

		try
		{
			LPCTSTR lpCmdLine = GetCommandLine();

			JetByteTools::CComExeServer::Run(hInstance, lpCmdLine);
		}
		catch (JetByteTools::CWin32Exception &e)
		{
			e.MessageBox();

			retVal = c_Failure;
		}
		catch (...)
		{
			::MessageBox(
				NULL, 
				_T("Unexpected Exception"), 
				_T("Program Failed"), 
				MB_ICONINFORMATION);
		
			retVal = c_Failure;
		}
	}
	else
	{
      ::MessageBox(
			NULL, 
			_T("Failed to AfxWinInit"), 
			_T("Error"), 
			MB_ICONINFORMATION);
	}

	return retVal;
}

#endif

void ModuleLock()
{
	JetByteTools::CComExeServer::Lock();
}

void ModuleUnlock()
{
	JetByteTools::CComExeServer::Unlock();
}

#endif // __COM_EXE_SERVER_MAIN__

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
