#ifndef __COM_GUID__
#define __COM_GUID__
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: ComGUID.hpp $
// Version        : $Revision: 2 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 29/11/99 0:37 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /Source/JetByteTools/COMTools/ComGUID.hpp $
// 
// 2     29/11/99 0:37 Len
// More static members for general GUID manipulation.
// 
// 1     22/07/99 23:56 Len
// Moved to source safe
// 
//    Rev 1.4   May 13 1999 23:17:54   len
// LPTSTR rather than LPCTSTR
// 
//    Rev 1.3   Oct 25 1998 21:05:24   len
// Added GetDescription().
// 
//    Rev 1.2   Oct 25 1998 20:56:32   len
// 
//    Rev 1.1   Jun 06 1998 07:55:10   Len
// 
//    Rev 1.0   May 18 1998 07:34:44   Len
// Initial revision.
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1998 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#pragma warning(disable: 4201)   // nameless struct/union

#ifndef _WINDOWS_
//#define WIN32_LEAN_AND_MEAN
#include <windows.h>
//#undef WIN32_LEAN_AND_MEAN
#endif

#ifndef _INC_TCHAR
#include <tchar.h>
#endif

#pragma warning(disable: 4201)

#ifndef __REGISTRY_KEY__
#include "RegistryKey.hpp"
#endif 

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {
 
///////////////////////////////////////////////////////////////////////////////
// Classes defined in this file...
///////////////////////////////////////////////////////////////////////////////

class CComGUID;

///////////////////////////////////////////////////////////////////////////////
// Classes defined in other files...
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// CComGUID
///////////////////////////////////////////////////////////////////////////////

class CComGUID
{
   public :

		static LPTSTR AsString(const GUID &guid);
      static GUID FromString(LPCTSTR pGuidAsString);
      static GUID GenerateGuid();


      CComGUID(const GUID &guid);
      CComGUID(const CComGUID &rhs);
      CComGUID(LPCTSTR pGuidAsString);

      ~CComGUID();

      // This is who we are...

      LPTSTR AsString() const;

      LPTSTR Description() const;
      LPTSTR GetDescription() const;

      //bool TreatAs() const;

      operator const GUID() const { return m_guid; }

      //operator LPCTSTR() const { return AsString(); }

      CComGUID &operator=(const CComGUID &rhs);

   private :

      GUID m_guid;

      mutable LPTSTR m_pGuid;

      mutable LPTSTR m_pDesc;
      mutable LPTSTR m_pRealDesc;

      CRegistryKey m_regKey;
};

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

} // End of namespace JetByteTools 

#endif // __COM_GUID__

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
