#ifndef __COM_MESSAGE_FILTER__
#define __COM_MESSAGE_FILTER__
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: ComMessageFilter.hpp $
// Version        : $Revision: 1 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 22/07/99 23:56 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /JetByteTools/COM Tools/ComMessageFilter.hpp $
// 
// 1     22/07/99 23:56 Len
// Moved to source safe
// 
//    Rev 1.0   May 13 1999 23:18:16   len
// Initial revision.
//  
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1999 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#pragma warning(disable: 4201)   // nameless struct/union

#ifndef _WINDOWS_
#include <windows.h>
#endif

#ifndef __COM_EXCEPTION__
#include "ComException.hpp"
#endif

#pragma warning(disable: 4201)

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {
 
///////////////////////////////////////////////////////////////////////////////
// Classes defined in this file...
///////////////////////////////////////////////////////////////////////////////

class CComMessageFilter;

///////////////////////////////////////////////////////////////////////////////
// Classes defined in other files...
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// CComMessageFilter
///////////////////////////////////////////////////////////////////////////////

class CComMessageFilter : public IMessageFilter
{
   public :

		class Exception : public CComException
      {
         private :

            friend class CComMessageFilter;

            Exception(LPCTSTR pWhere, HRESULT hr)
               :  CComException(pWhere, hr)
            {
            }
      };

      CComMessageFilter();
      
		virtual ~CComMessageFilter();

		// Implement IUnknown

		STDMETHODIMP QueryInterface(REFIID riid, void**ppv);

		STDMETHODIMP_(ULONG) AddRef(void);

		STDMETHODIMP_(ULONG) Release(void);


		// *** IMessageFilter methods ***

		virtual STDMETHODIMP_(DWORD) HandleInComingCall(
			DWORD dwCallType, 
			HTASK htaskCaller,
			DWORD dwTickCount, 
			LPINTERFACEINFO lpInterfaceInfo);

		virtual STDMETHODIMP_(DWORD) RetryRejectedCall(
			HTASK htaskCaller,
			DWORD dwTickCount,
			DWORD dwRejectType );

		virtual STDMETHODIMP_(DWORD) MessagePending(
			HTASK htaskCaller,
			DWORD dwTickCount, 
			DWORD dwPendingType); 
	
   private :

		// Disallow copying, do not implement!

		CComMessageFilter(const CComMessageFilter &rhs);
		CComMessageFilter &operator=(const CComMessageFilter &rhs);

	LPMESSAGEFILTER m_pOldMessageFilter;
};

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

} // End of namespace JetByteTools 

#endif // __COM_MESSAGE_FILTER__

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
