#ifndef __COM_USES_SECURITY__
#define __COM_USES_SECURITY__
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: ComUsesSecurity.hpp $
// Version        : $Revision: 2 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 6/03/00 7:43 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /Source/JetByteTools/COMTools/ComUsesSecurity.hpp $
// 
// 2     6/03/00 7:43 Len
// Exclude from build unless we're building for NT 4 / Win95 + DCOM only.
// 
// 1     22/07/99 23:56 Len
// Moved to source safe
// 
//    Rev 1.0   May 13 1999 23:18:56   len
// Initial revision.
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1999 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM)

#include "ComUsesCom.hpp"

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {
 
///////////////////////////////////////////////////////////////////////////////
// Classes defined in this file...
///////////////////////////////////////////////////////////////////////////////

class CComUsesSecureCom;

///////////////////////////////////////////////////////////////////////////////
// Classes defined in other files...
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// CComUsesCom
///////////////////////////////////////////////////////////////////////////////

class CComUsesSecurity : public CComUsesCom
{
   public :

      // Exceptions we might throw

      class Exception : public CComException
      {
         private :

            friend class CComUsesSecurity;

            Exception(LPCTSTR pWhere, HRESULT hr)
               :  CComException(pWhere, hr)
            {
            }

				static void ThrowOnFailure(LPCTSTR pWhere, HRESULT hr)
				{
					if (FAILED(hr))
					{
						throw Exception(pWhere, hr);
					}
				}
      };

		CComUsesSecurity(
			DWORD dwCoInit = COINIT_APARTMENTTHREADED,
			DWORD dwAuthLevel = RPC_C_AUTHN_LEVEL_NONE,
			DWORD dwImplLevel = RPC_C_IMP_LEVEL_ANONYMOUS,
			DWORD dwCapabilities = EOAC_NONE);

      virtual ~CComUsesSecurity();

};

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

} // End of namespace JetByteTools 

#endif // (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM)

#endif // __COM_USES_SECURITY__

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
