///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: GUIDRegistryList.cpp $
// Version        : $Revision: 2 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 29/11/99 0:38 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /Source/JetByteTools/COMTools/GUIDRegistryList.cpp $
// 
// 2     29/11/99 0:38 Len
// Re change in base class.
// 
// 1     22/07/99 23:56 Len
// Moved to source safe
// 
//    Rev 1.1   May 13 1999 23:10:36   len
// Comment out unused params
// 
//    Rev 1.0   Jun 06 1998 07:55:46   Len
// Initial revision.
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1998 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Include files
///////////////////////////////////////////////////////////////////////////////

#include "GUIDRegistryList.hpp"

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {

///////////////////////////////////////////////////////////////////////////////
// CGUIDRegistryList
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Construction and destruction
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Default implementation...
///////////////////////////////////////////////////////////////////////////////

CGUIDRegistryList::CGUIDRegistryList(const CRegistryKey &key)
   :  TRegistryList<CComGUID>(key)
{
}


LPCTSTR CGUIDRegistryList::GetItemName(CComGUID &item)
{
   return item.AsString();
}

void CGUIDRegistryList::AddItem(CRegistryKey &/*key*/, CComGUID &/*item*/)
{

}

void CGUIDRegistryList::UpdateItem(CRegistryKey &/*key*/, CComGUID &/*item*/)
{

}

void CGUIDRegistryList::RemoveItem(CRegistryKey &/*key*/, CComGUID &/*item*/)
{

}

CComGUID *CGUIDRegistryList::ReadItem(const iterator &it) const
{
   CComGUID *pGuid = new CComGUID(it.GetName());

   // do stuff with it

   return pGuid;
}

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

} // End of namespace JetByteTools 

///////////////////////////////////////////////////////////////////////////////
// End of file...
///////////////////////////////////////////////////////////////////////////////
