#ifndef __NM_CALL__
#define __NM_CALL__
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: NMCall.hpp $
// Version        : $Revision: 1 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 31/07/99 9:29 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /Source/JetByteTools/NMTools/NMCall.hpp $
// 
// 1     31/07/99 9:29 Len
// 
//    Rev 1.0   May 13 1999 22:36:20   len
// Initial revision.
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1999 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#include "NmInterfaces.h"
#include "NmException.hpp"
#include "ComNotify.hpp"

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {
 
///////////////////////////////////////////////////////////////////////////////
// Classes defined in this file...
///////////////////////////////////////////////////////////////////////////////

class CNmCall;

///////////////////////////////////////////////////////////////////////////////
// Classes defined in other files...
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// CNmCall
///////////////////////////////////////////////////////////////////////////////

class CNmCall : public INmCallNotify, private CComNotify
{
   public :

		class Exception : public CNmException
		{
			friend class CNmCall;

			private :

				Exception(LPCTSTR pWhere, HRESULT hr) 
					: CNmException(pWhere, hr) {}

		};

      CNmCall(
			INmCall *pICall,
			const bool bAutoConnect = false);

		CNmCall(const CNmCall &rhs);

		
		~CNmCall();

		// Implement CNmCall

		void Accept();

		void Cancel();

		//GetAddr  
		INmConference *GetConference();

		LPCTSTR GetName();

		//GetState  
		//GetUserData  
		bool IsIncoming();
		void Reject();

		operator INmCall *();

		void Connect();

		// Implement INmCallNotify
	
		// IUnknown methods
		ULONG STDMETHODCALLTYPE AddRef();
		ULONG STDMETHODCALLTYPE Release();
		HRESULT STDMETHODCALLTYPE QueryInterface(
			REFIID riid, 
			PVOID *ppvObj);

      HRESULT STDMETHODCALLTYPE NmUI(
			CONFN uNotify);
        
      HRESULT STDMETHODCALLTYPE StateChanged( 
			NM_CALL_STATE uState);
        
      HRESULT STDMETHODCALLTYPE Failed( 
			ULONG uError);
        
		HRESULT STDMETHODCALLTYPE Accepted( 
			INmConference __RPC_FAR *pConference);

	private : 

		CNmCall &operator=(const CNmCall &rhs);

		INmCall *m_pICall;
};

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

} // End of namespace JetByteTools 

#endif // __NM_CALL__

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
