#ifndef __NM_CHANNEL_DATA__
#define __NM_CHANNEL_DATA__
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: NMChannelData.hpp $
// Version        : $Revision: 1 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 23/07/99 0:00 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /JetByteTools/NetMeeting Tools/NMChannelData.hpp $
// 
// 1     23/07/99 0:00 Len
// Moved to source safe
// 
//    Rev 1.0   May 13 1999 22:29:10   len
// Initial revision.
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1999 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#include "NmInterfaces.h"
#include "NmChannel.hpp"
#include "NmException.hpp"
#include "ComNotify.hpp"

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {
 
///////////////////////////////////////////////////////////////////////////////
// Classes defined in this file...
///////////////////////////////////////////////////////////////////////////////

class CNmChannelData;

///////////////////////////////////////////////////////////////////////////////
// Classes defined in other files...
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// CNmDataChannel
///////////////////////////////////////////////////////////////////////////////

class CNmChannelData : public INmChannelDataNotify, private CComNotify
{
   public :

		class Exception : public CNmException
		{
			friend class CNmChannelData;

			private :

				Exception(LPCTSTR pWhere, HRESULT hr) 
					: CNmException(pWhere, hr) {}

		};

      CNmChannelData(
			INmChannelData *pIChannelData,
			const bool bAutoConnect = false);

		CNmChannelData(const CNmChannelData &rhs);

		CNmChannelData(
			INmChannel *pIChannel,
			const bool bAutoConnect = false);

		~CNmChannelData();

		// Conversion to underlying pointer...

		operator INmChannelData *();

		void Connect();

		// Implement INmChannelData

		GUID GetGuid();

		void SendData(
			INmMember *pMember,
			ULONG uSize,
			BYTE *pvBuffer,
			ULONG uOptions);

/*		void SendData(
			CNmMember &member,
			ULONG uSize,
			BYTE *pvBuffer,
			ULONG uOptions);
*/
		// Implement INmChannelDataNotify
	
		// IUnknown methods
		ULONG STDMETHODCALLTYPE AddRef(void);
		ULONG STDMETHODCALLTYPE Release(void);
		HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, PVOID *ppvObj);

		HRESULT STDMETHODCALLTYPE DataReceived(
			INmMember *pMember,
			ULONG uSize,
			byte *pvBuffer,
			ULONG dwFlags);

		HRESULT STDMETHODCALLTYPE DataSent(
			INmMember *pMember,
			ULONG uSize,
			byte *pvBuffer);

		HRESULT STDMETHODCALLTYPE MemberChanged(
			NM_MEMBER_NOTIFY uNotify, 
			INmMember *pMember);


		HRESULT STDMETHODCALLTYPE NmUI(
			CONFN uNotify);

	private : 

		CNmChannelData &operator=(const CNmChannelData &rhs);

		INmChannelData *m_pIChannelData;
};

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

} // End of namespace JetByteTools 

#endif // __NM_CHANNEL_DATA__

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
