#ifndef __ITERATE_NM_CHANNEL__
#define __ITERATE_NM_CHANNEL__
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: NMIterateChannel.hpp $
// Version        : $Revision: 1 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 23/07/99 0:00 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /JetByteTools/NetMeeting Tools/NMIterateChannel.hpp $
// 
// 1     23/07/99 0:00 Len
// Moved to source safe
// 
//    Rev 1.0   May 13 1999 22:30:46   len
// Initial revision.
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1998 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef __IENUM_ITERATOR__
#include "IEnumIterator.hpp"
#endif

#ifndef __NMInterfaces_h__
#include "NmInterfaces.hpp"
#endif

#ifndef __objidl_h__
#include "OBJIDL.H"
#endif

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {
 
///////////////////////////////////////////////////////////////////////////////
// Classes defined in this file...
///////////////////////////////////////////////////////////////////////////////

class CIterateNmChannel;

///////////////////////////////////////////////////////////////////////////////
// Classes defined in other files...
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// CIterateNmChannel
///////////////////////////////////////////////////////////////////////////////

class CIterateNmChannel
   :  public IEnumIterator<CIterateNmChannel, IEnumNmChannel, INmChannel *>
{
   public :

      CIterateNmChannel(IEnumNmChannel *pIEnumChannel, unsigned long max = 64) 
         : IEnumIterator<CIterateNmChannel, IEnumNmChannel, INmChannel *> (pIEnumChannel, max)
      {
      }

	private :

		virtual void Destroy(INmChannel *pChannel) const 
		{ 
			pChannel->Release();
		}
		
		virtual INmChannel *Copy(INmChannel *pChannel) const 
		{
			pChannel->AddRef();

			return pChannel;
		}
};


///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

} // End of namespace JetByteTools 

#endif // __ITERATE_NM_CHANNEL__

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
