///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: NMMessages.cpp $
// Version        : $Revision: 1 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 23/07/99 0:00 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /JetByteTools/NetMeeting Tools/NMMessages.cpp $
// 
// 1     23/07/99 0:00 Len
// Moved to source safe
// 
//    Rev 1.0   May 13 1999 22:28:24   len
// Initial revision.
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1999 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Include files
///////////////////////////////////////////////////////////////////////////////

#include "NmMessages.hpp"
#include "NmMember.hpp"
#include "NmChannel.hpp"
#include <stdio.h>
#include <wchar.h>

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {

///////////////////////////////////////////////////////////////////////////////
// CNmMessages
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Static member functions
///////////////////////////////////////////////////////////////////////////////

LPTSTR CNmMessages::NmUI(CONFN uNotify)
{
	LPTSTR pWhat = _T("NmUI - Unknown event");

	switch (uNotify)
	{
		case CONFN_FT_UI : 
			pWhat = _T("FT UI");
		break;

		case CONFN_FT_OFFERED : 
			pWhat = _T("FT OFFERED");
		break;

		case CONFN_FT_STARTED : 
			pWhat = _T("FT STARTED");
		break;

		case CONFN_FT_PROGRESS : 
			pWhat = _T("FT PROGRESS");
		break;

		case CONFN_FT_COMPLETE : 
			pWhat = _T("FT COMPLETE");
		break;

		case CONFN_FT_CANCELED : 
			pWhat = _T("FT CANCELED");
		break;

		case CONFN_CLICK_CONTROL : 
			pWhat = _T("CLICK CONTROL");
		break;

		case CONFN_CLICK_OBSCURE : 
			pWhat = _T("CLICK OBSCURE");
		break;

		case CONFN_CLICK_REMOTE_NOT_COLLABORATING : 
			pWhat = _T("CLICK REMOTE NOT COLLABORATING");
		break;

		case CONFN_CLICK_LOCAL_NOT_COLLABORATING : 
			pWhat = _T("CLICK LOCAL NOT COLLABORATING");
		break;

		case CONFN_CALL_INCOMPATIBLE : 
			pWhat = _T("CALL INCOMPATIBLE");
		break;

		case CONFN_CALL_OLDER : 
			pWhat = _T("CALL OLDER");
		break;

		case CONFN_CALL_NEWER : 
			pWhat = _T("CALL NEWER");
		break;

		case CONFN_CALL_IGNORED : 
			pWhat = _T("CALL IGNORED");
		break;

		case CONFN_CALL_FAILED : 
			pWhat = _T("CALL FAILED");
		break;

		case CONFN_CALL_IN_CONFERENCE : 
			pWhat = _T("CALL IN CONFERENCE");
		break;

		case CONFN_NM_STARTED : 
			pWhat = _T("NM STARTED");
		break;

		case CONFN_NM_STOPPED : 
			pWhat = _T("NM STOPPED");
		break;
	}

	return pWhat;
}

LPTSTR CNmMessages::StateChanged(NM_CONFERENCE_STATE uState)
{
	LPTSTR pWhat = _T("StateChanged - Unknown event");

	switch (uState)
	{
		case NM_CONFERENCE_IDLE : 
			pWhat = _T("Conference idle");
		break;

		case NM_CONFERENCE_WAITING : 
			pWhat = _T("Conference waiting"); 
		break;

		case NM_CONFERENCE_INITIALIZING	: 
			pWhat = _T("Conference initializing");
		break;

		case NM_CONFERENCE_ACTIVE	:
			pWhat = _T("Conference active");
		break;
	}
	
	return pWhat;
}

LPTSTR CNmMessages::MemberChanged(
	NM_MEMBER_NOTIFY uNotify, 
	INmMember *pMember)
{
	LPTSTR pWhat = _T("MemberChanged - Unknown event");

	switch (uNotify)
	{
		case NM_MEMBER_ADDED :
			pWhat = _T("Member added");
		break;

		case NM_MEMBER_REMOVED :
			pWhat = _T("Member removed");
		break;

		
		case NM_MEMBER_UPDATED :
			pWhat = _T("Member updated");
		break;

	}

	CNmMember member(pMember);

	LPCTSTR pName = member.GetName();

	static TCHAR buffer[300]; // yuck

	_stprintf(buffer, _T("%s - %s - %s %d %d"), pWhat, pName, (member.IsDataChannelActive() ? "Active" : "Inactive"), member.GetChannelCapabilities(), member.IsMCU());

	free((void*)pName);

	return buffer;
}

LPTSTR CNmMessages::ChannelChanged(
	NM_CHANNEL_NOTIFY uNotify, 
	INmChannel *pChannel)
{
	LPTSTR pWhat = _T("ChannelChanged - Unknown event");

	switch (uNotify)
	{
		case NM_CHANNEL_ADDED :		
			pWhat = _T("Channel added");
		break;

		case NM_CHANNEL_REMOVED :
			pWhat = _T("Channel removed");
		break;
	
		case NM_CHANNEL_UPDATED :			
			pWhat = _T("Channel updated");
		break;
	}

	CNmChannel channel(pChannel);

	LPTSTR pType = _T("Unknown Type");

	switch (channel.GetChannelType())
	{
		case NMCH_NONE :
			pType = _T("(none)");
		break ;

		case NMCH_DATA :
			{
			pType = _T("(data)");

//			JetByteTools::CNmChannelData data(channel);

//			what += JetByteTools::CComGUID::AsString(data.GetGuid());
			}

		break;

		case NMCH_AUDIO :
			pType = _T("(audio)");
		break;

		case NMCH_VIDEO :
			pType = _T("(video)");
		break;

		case NMCH_SHARE :
			pType = _T("(share)");
		break;

		case NMCH_FT :
			pType = _T("(file transfer)");
		break;
	}

	static TCHAR buffer[300]; // yuck

	_stprintf(buffer, _T("%s - %s - %s - %d"), pWhat, pType, (channel.IsActive() ? "Active" : "Inactive"), channel.GetMemberCount());

	return buffer;
}

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

} // End of namespace JetByteTools 

///////////////////////////////////////////////////////////////////////////////
// End of file...
///////////////////////////////////////////////////////////////////////////////
