#ifndef __NM_SYSTEM_INFO__
#define __NM_SYSTEM_INFO__
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: NMSystemInfo.hpp $
// Version        : $Revision: 1 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 23/07/99 0:00 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /JetByteTools/NetMeeting Tools/NMSystemInfo.hpp $
// 
// 1     23/07/99 0:00 Len
// Moved to source safe
// 
//    Rev 1.0   May 13 1999 22:31:34   len
// Initial revision.
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1999 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#include "NmInterfaces.h"
#include "NmException.hpp"

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {
 
///////////////////////////////////////////////////////////////////////////////
// Classes defined in this file...
///////////////////////////////////////////////////////////////////////////////

class CNmSystemInfo;

///////////////////////////////////////////////////////////////////////////////
// Classes defined in other files...
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// CNmSystemInfo
///////////////////////////////////////////////////////////////////////////////

class CNmSystemInfo 
{
   public :

		class Exception : public CNmException
		{
			friend class CNmSystemInfo;

			private :

				Exception(LPCTSTR pWhere, HRESULT hr) 
					: CNmException(pWhere, hr) {}

		};

      CNmSystemInfo(INmSysInfo *pISysInfo);

		CNmSystemInfo(const CNmSystemInfo &rhs);


		~CNmSystemInfo();

		// Implement INmSysInfo

		//GetLaunchInfo
		//GetApp
		bool GetChannelCapabilities(
			ULONG &channelCapabilities);
		
		LPTSTR GetProperty(
			NM_SYSPROP property);

		//GetUserData()
		//IsInstalled()
		//SetApp()
		
		void SetProperty(NM_SYSPROP property, LPCTSTR pValue);

		//SetUserData()

	private : 
		
		CNmSystemInfo &operator=(const CNmSystemInfo &rhs);

		INmSysInfo *m_pISysInfo;

};

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

} // End of namespace JetByteTools 

#endif // __NM_SYSTEM_INFO__

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
