// PingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Ping.h"
#include "PingDlg.h"

#include <mmsystem.h>

#include "NmChannel.hpp"
#include "NmMember.hpp"
#include "NmChannelData.hpp"

#include "ComGuid.hpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <initguid.h>
// {28B9D76E-AFE0-11d2-80BF-0020186676FB}
DEFINE_GUID(myGuid, 
0x28b9d76e, 0xafe0, 0x11d2, 0x80, 0xbf, 0x0, 0x20, 0x18, 0x66, 0x76, 0xfb);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPingDlg dialog

CPingDlg::CPingDlg(CWnd* pParent /*=NULL*/)
	:	CDialog(CPingDlg::IDD, pParent),
		m_bTimerRunning(false),
		m_bTimerCanRun(false),
		m_nextOut(0),
		m_nextIn(0),
		m_processID(GetCurrentProcessId())
{
	//{{AFX_DATA_INIT(CPingDlg)
	m_payload = 256;
	m_frequency = 0;
	m_missedPackets = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	TIMECAPS tc;

	if (timeGetDevCaps(&tc, sizeof(TIMECAPS)) == TIMERR_NOERROR) 
	{
		m_timerRes = min(max(tc.wPeriodMin, 1), tc.wPeriodMax);
		timeBeginPeriod(m_timerRes); 
	}
}

CPingDlg::~CPingDlg()
{
	if (m_timerRes)
	{
		timeBeginPeriod(m_timerRes);
	}
}

void CPingDlg::DoDataExchange(CDataExchange* pDX)
{
	const int minPayload = 3 * sizeof(DWORD);

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPingDlg)
	DDX_Control(pDX, IDC_LIST1, m_list);
	DDX_Text(pDX, IDC_EDIT1, m_payload);
	DDV_MinMaxUInt(pDX, m_payload, minPayload, 4096);
	DDX_Text(pDX, IDC_EDIT2, m_frequency);
	DDV_MinMaxUInt(pDX, m_frequency, 0, 1000);
	DDX_Text(pDX, IDC_EDIT3, m_missedPackets);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPingDlg, CDialog)
	//{{AFX_MSG_MAP(CPingDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_UPDATE(IDC_EDIT1, OnUpdateEdit1)
	ON_EN_UPDATE(IDC_EDIT2, OnUpdateEdit2)
	ON_BN_CLICKED(IDC_APPLY, OnApply)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPingDlg message handlers

BOOL CPingDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	AddString(_T("DISCONNECTED"));
	Initialise(myGuid, NM_INIT_NORMAL, NMCH_ALL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPingDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPingDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPingDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPingDlg::OnUpdateEdit1() 
{
	EnableButton(IDC_APPLY);
}

void CPingDlg::OnUpdateEdit2() 
{
	EnableButton(IDC_APPLY);
}

void CPingDlg::OnApply() 
{
	UpdateData(TRUE);

	ResetTimer();

	DisableButton(IDC_APPLY);
}


void CPingDlg::DisableButton(int buttonId)
{
   CButton *pButton = (CButton*)GetDlgItem(buttonId);

   if (pButton)
   {
      pButton->EnableWindow(FALSE);
   }
}

void CPingDlg::EnableButton(int buttonId)
{
   CButton *pButton = (CButton*)GetDlgItem(buttonId);

   if (pButton)
   {
      pButton->EnableWindow(TRUE);
   }
}

void CPingDlg::AddString(LPCTSTR pString)
{
	int item = m_list.AddString(pString);
	m_list.SetTopIndex(item);
}

void CPingDlg::OnTimer(UINT nIDEvent) 
{
	// Send the message here..

	CTime now(CTime::GetCurrentTime());

	DWORD msecs = timeGetTime();
	
	static unsigned char buffer[4096];

	unsigned char *pBuff = buffer;

	*(DWORD*)pBuff = m_nextOut++;

	pBuff += sizeof(DWORD);

	*(DWORD*)pBuff = msecs;
	
	pBuff += sizeof(DWORD);

	*(DWORD*)pBuff = m_processID;

		
	SendData(m_payload, buffer);

	CDialog::OnTimer(nIDEvent);
}


HRESULT STDMETHODCALLTYPE CPingDlg::DataReceived(
	INmMember *pMember,
	ULONG uSize,
	byte *pvBuffer,
	ULONG dwFlags)
{
	unsigned char *pBuf = pvBuffer;

	DWORD counter = *(DWORD*)pBuf;

	pBuf += sizeof(DWORD);

	DWORD msecsStart = *(DWORD*)pBuf;

	pBuf += sizeof(DWORD);

	DWORD processID = *(DWORD*)pBuf;

//	if (counter != m_nextIn && counter != 0)
//	{
//		m_missedPackets++;
//
//		UpdateData(FALSE);
//	}
//	m_nextIn = counter + 1;

	if (m_processID != processID)
	{
//		CString message;
//		message.Format("%lu - %lu bytes - echoed", counter, uSize);
//		AddString(message);

		SendData(uSize, pvBuffer, pMember, dwFlags);
	}
	else
	{
		DWORD msecsEnd = timeGetTime();

		JetByteTools::CNmMember member(pMember);

		LPCTSTR pName = member.GetName();

		CString name(pName);

		free((void*)pName);

		CString message;

		message.Format(_T("%lu - %lu bytes -  %lu msecs"), counter, uSize, (DWORD)(msecsEnd - msecsStart));

		message = name + _T(": ") + message;

		AddString(message);
	}

	return S_OK;
}


HRESULT STDMETHODCALLTYPE CPingDlg::DataSent(
	INmMember * /* pMember */,
	ULONG /* uSize */,
	byte * /* pvBuffer */)
{
	return S_OK;
}

void CPingDlg::OnConnected()
{
	AddString(_T("CONNECTED"));
	
	m_bTimerCanRun = true;
	StartTimer();
}

void CPingDlg::OnDisconnected()
{
	AddString(_T("DISCONNECTED"));

	m_bTimerCanRun = false;
	StopTimer();
}

void CPingDlg::StartTimer()
{
	if (m_bTimerCanRun && !m_bTimerRunning && m_frequency != 0)
	{
		SetTimer(1, 1000 * m_frequency, 0);

		m_bTimerRunning = true;
	}
}

void CPingDlg::StopTimer()
{
	if (m_bTimerRunning )
	{
		KillTimer(1);
		
		m_bTimerRunning = false;
	}
}

void CPingDlg::ResetTimer()
{
	if (m_bTimerCanRun)
	{
		StopTimer();
		StartTimer();
	}
}

void CPingDlg::Error(LPCTSTR pMessage)
{
	AddString(pMessage);
}

/*
HRESULT STDMETHODCALLTYPE CPingDlg::ChannelChanged(
	NM_CHANNEL_NOTIFY uNotify, 
	INmChannel *pChannel)
{
	CString what = "Unknown event";

	switch (uNotify)
	{
		case NM_CHANNEL_ADDED :
			
			what = "Channel added";

		break;

		case NM_CHANNEL_REMOVED :
			
			what = "Channel removed";

		break;

		
		case NM_CHANNEL_UPDATED :
			
			what = "Channel updated";

		break;

	}

	what += " ";

	JetByteTools::CNmChannel channel(pChannel);

	channel.Connect();

	switch (channel.GetChannelType())
	{
		case NMCH_NONE :
		
			what += "(none)";

		break ;

		case NMCH_DATA :
			{
			what += "(data)";

			JetByteTools::CNmChannelData data(channel);

			what += JetByteTools::CComGUID::AsString(data.GetGuid());
			}

		break;

		case NMCH_AUDIO :
		
			what += "(audio)";

		break;

		case NMCH_VIDEO :
		
			what += "(video)";

		break;

		case NMCH_SHARE :
		
			what += "(share)";

		break;

		case NMCH_FT :
		
			what += "(file transfer)";

		break;
	}

	AddString(what);
	
	return CNmDataPipe::ChannelChanged(uNotify, pChannel);
}
*/
