#ifndef __CPL_APPLET_CLIENT__
#define __CPL_APPLET_CLIENT__
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: CPlAppletClient.hpp $
// Version        : $Revision: 1 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 22/07/99 23:59 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /JetByteTools/Win32 Tools/CPlAppletClient.hpp $
// 
// 1     22/07/99 23:59 Len
// Moved to source safe
// 
//    Rev 1.2   Jun 04 1998 00:00:12   Len
// Only include what we need, disable copying.
// 
//    Rev 1.1   May 18 1998 07:48:56   Len
// Changes to make the code compile as UNICODE.
// 
//    Rev 1.0   Dec 28 1997 12:16:02   Len
// Initial revision.
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1997 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Include files
///////////////////////////////////////////////////////////////////////////////

#pragma warning(disable: 4201)   // nameless struct/union

#ifndef _WINDOWS_
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#undef WIN32_LEAN_AND_MEAN
#endif

#ifndef _INC_TCHAR
#include <tchar.h>
#endif

#ifndef _INC_CPL
#include "cpl.h"
#endif

#pragma warning(default: 4201)

#include <assert.h>

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {

///////////////////////////////////////////////////////////////////////////////
// Classes defined in this file
///////////////////////////////////////////////////////////////////////////////

class CPlAppletClient;

///////////////////////////////////////////////////////////////////////////////
// CPlAppletClient
///////////////////////////////////////////////////////////////////////////////

class CPlAppletClient 
{
   public :

      // Construction and destruction

      CPlAppletClient(LPCTSTR lpCPlAppletName, const int nAppIndex = 0);
      ~CPlAppletClient();

      // Applet manipulation

      bool LoadApplet(HWND hWnd);

      bool RunApplet(HWND hWnd);

      bool UnloadApplet(HWND hWnd);

      HICON GetIcon();

      LPCTSTR GetAppName();

      LPCTSTR GetInfo();

   private :

      bool GetCPlInfo(HWND hWnd);

      HINSTANCE m_hLibInstance;
      LPCTSTR m_lpCPlAppletName;
      const int m_nAppIndex;

      HICON m_hIcon;

      APPLET_PROC m_pAppletProc;
      long m_lData;

      TCHAR m_szAppName[32];
      TCHAR m_szAppInfo[64];

      CPLINFO m_CplInfo;
      NEWCPLINFO m_NewCplInfo;

      bool m_bNewCpl;

      // No copying - do not implement

      CPlAppletClient(const CPlAppletClient &rhs);
      CPlAppletClient &operator=(const CPlAppletClient &rhs);

};

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

} // End of namespace JetByteTools 

#endif // __CPL_APPLET_CLIENT__

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
