#ifndef __EVENT_LOGGER__
#define __EVENT_LOGGER__
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: EventLogger.hpp $
// Version        : $Revision: 1 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 31/07/99 9:30 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /Source/JetByteTools/Win32Tools/EventLogger.hpp $
// 
// 1     31/07/99 9:30 Len
// 
//    Rev 1.0   May 18 1998 07:49:22   Len
// Initial revision.
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1998 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING 
// ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
// OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. JETBYTE LIMITED AND ITS LICENSORS 
// SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF 
// USING, MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO 
// EVENT WILL JETBYTE LIMITED BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, 
// OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
// DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING 
// OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF JETBYTE LIMITED 
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
///////////////////////////////////////////////////////////////////////////////

#include "Singleton.hpp"
#include "EventLog.hpp"

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {

///////////////////////////////////////////////////////////////////////////////
// Templates defined in this file...
///////////////////////////////////////////////////////////////////////////////

template <class T> class TEventLogger;

///////////////////////////////////////////////////////////////////////////////
// TEventLogger 
///////////////////////////////////////////////////////////////////////////////

template <class T> class TEventLogger : public TSingleton<T>, private CEventLog
{
   public :

      TEventLogger(LPCTSTR pName, LPCTSTR pUNCServerName = 0);
      
      virtual ~TEventLogger();

      using CEventLog::RegisterMessageFile;

   protected :

      using CEventLog::ReportEvent;
};


template <class T> TEventLogger<T>::TEventLogger(
   LPCTSTR pName, 
   LPCTSTR pUNCServerName /* = 0*/)
   :  CEventLog(pName, pUNCServerName)
{
   // All work done in the initialiser list
}

template <class T> TEventLogger<T>::~TEventLogger()
{
   // We just need to have a virtual destructor...
}

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools
///////////////////////////////////////////////////////////////////////////////

} // End of namespace JetByteTools 

#endif // __EVENT_LOGGER__

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
